/**
 * QuilJs
 * Used to generate our QuilJs powered shownotes section.
 */

jQuery(document).ready(function($){

	var quill_container = '#cfm-field-wpeditor';

	if ( $( quill_container ).length ){

		var toolbarOptions = [
			['bold', 'italic', 'underline', 'strike'],        // toggled buttons
			['blockquote'],
			[{ 'size': ['small', false, 'large', 'huge'] }],
			[{ 'header': 1 }, { 'header': 2 }],
			[{ 'list': 'ordered'}, { 'list': 'bullet' }],
			[{ 'align': [] }],
			['link']
		];

		var quill = new Quill(
			quill_container,
			{
				modules: {
					toolbar: toolbarOptions
				},
				placeholder: 'Insert text here ...',
				theme: 'snow'
			}
		);

		var form = document.querySelector( 'form' );
		form.onsubmit = function() {
			var myEditor = document.querySelector( quill_container ),
				html = myEditor.children[0].innerHTML;
			// Populate hidden form on submit.
			var about = document.querySelector( 'textarea[name=post_content]' );
			about.value = html;
		};

		quill.on(
			'text-change',
			function(delta, source) {
				var myEditor = document.querySelector( quill_container ),
				html = myEditor.children[0].innerHTML;

				if ( html != '' && html != '<p><br></p>' ) {
					$( '#cfm-field-wpeditor' ).removeClass( 'cfm-field-error' );
					$( '.cfm-show-description .ql-toolbar.ql-snow' ).removeClass( 'cfm-field-error' );
					$( '#shownotes-error' ).remove();
				}
			}
		);

	}

});
